#include <fggl/gfx/ogl/backend.hpp>

#include <stdexcept>
#include <spdlog/spdlog.h>

using namespace fggl::gfx;

GlGraphics::GlGraphics(const std::shared_ptr<Window> window) : m_window(window) {
    spdlog::debug("[OGL] attaching window context");
	window->activate();
	GLenum err = glewInit();
	if ( GLEW_OK != err ) {
		throw std::runtime_error("couldn't init glew");
	}

	glViewport(0, 0, 1920, 1080);
    spdlog::debug("[OGL] window context ready");
}

GlGraphics::~GlGraphics() {
    spdlog::debug("[OGL] gl window context killed!");
}

void GlGraphics::clear() {
	m_window->activate();

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
}
