
#ifndef FGGL_GFX_WINDOWING_H
#define FGGL_GFX_WINDOWING_H

#include <memory>

namespace fggl::gfx {

    class Graphics {
        public:
            virtual void clear();
    };

    class Window {
        public:
            Window();

            template<typename T>
            void make_graphics() {
                m_graphics = std::make_unique<T>();
            }

        private:
            std::unique_ptr<Graphics> m_graphics;
    };

    class WindowService {
        public:
            Window& create();
    };

} // namespace fggl::gfx

#endif
